diff -Naur test-for-latech/include/linux/qfabric.h testqf-for-latech/include/linux/qfabric.h
--- test-for-latech/include/linux/qfabric.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/include/linux/qfabric.h	2004-06-11 07:47:29.000000000 -0400
@@ -0,0 +1,75 @@
+#ifndef	__QFABRIC__H__
+#define	__QFABRIC__H__
+
+#ifdef __KERNEL__
+#include <linux/socket.h>
+
+extern struct socket *look_up_pseudofd(int fd, struct socket *fd_array[]);
+extern int get_pseudofd(struct socket *sock, struct socket *fd_array[]);
+extern int release_pseudofd(int fd, struct socket *fd_array[]);
+extern void initialize_qfabric(void);
+
+#else
+
+#ifndef CONFIG_QFABRIC
+#define CONFIG_QFABRIC
+#endif
+
+#include <sys/syscall.h>
+#include <linux/a.out.h>
+#include <linux/module.h>
+#include <sys/time.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <errno.h>
+#include <unistd.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+extern int query_module(const char *, int, void *, size_t, size_t);
+extern int qfabric_config(char *app_id, char *group_id);
+
+/* system call: kecho_load. */
+_syscall2(int, kecho_load,
+          char *, module_name,
+	  int, argument);
+
+_syscall1(int, KECho_syscall_echo,
+          void *, echo_data);
+
+#ifdef CONFIG_X86
+_fast_syscall1(int, fast_KECho_syscall_echo,
+          void *, echo_data);
+#endif
+
+_syscall1(int, KECho_syscall_cm,
+          void *, cm_data);
+
+#ifdef CONFIG_X86
+_fast_syscall1(int, fast_KECho_syscall_cm,
+          void *, cm_data);
+#endif
+
+_syscall1(int, KECho_syscall_cg,
+          void *, cm_data);
+
+#ifdef CONFIG_X86
+_fast_syscall1(int, fast_KECho_syscall_cg,
+          void *, cm_data);
+#endif
+
+_syscall1(int, KECho_syscall_atl,
+          void *, atl_data);
+
+#ifdef CONFIG_X86
+_fast_syscall1(int, fast_KECho_syscall_atl,
+          void *, atl_data);
+#endif
+
+_syscall2(int, qos_configure,
+	  char *, app_id,
+	  char *, group_id);
+
+#endif /* __KERNEL__ */
+#endif /* __QFABRIC__H__ */
diff -Naur test-for-latech/include/linux/qf_api.h testqf-for-latech/include/linux/qf_api.h
--- test-for-latech/include/linux/qf_api.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/include/linux/qf_api.h	2004-06-11 07:47:29.000000000 -0400
@@ -0,0 +1,24 @@
+#ifndef	__QFAPI__H__
+#define	__QFAPI__H__
+
+#include <sys/syscall.h>
+#include <linux/a.out.h>
+#include <linux/module.h>
+#include <sys/time.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <errno.h>
+#include <unistd.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+_syscall2(int, change_clock,
+	  int, flag,
+	  int, value);
+
+_syscall2(int, qos_configure,
+	  char *, app_id,
+	  char *, group_id);
+
+#endif 
diff -Naur test-for-latech/include/linux/qos_conf.h testqf-for-latech/include/linux/qos_conf.h
--- test-for-latech/include/linux/qos_conf.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/include/linux/qos_conf.h	2004-06-11 07:47:29.000000000 -0400
@@ -0,0 +1,63 @@
+/*File          :qos_conf.h
+ *Written by    :Rabin Patra & Vibha Rathi
+ *Date          :12 July 2001
+ *
+ *Definations for:
+ *1.struct qos_request
+ *2.struct qos_msg
+ *3.struct qos_syscall_msg
+ */
+
+
+#ifndef __QOS_CONF_H__
+#define __QOS_CONF_H__ 1
+
+#include <linux/netlink.h>
+#include <linux/rtnetlink.h>
+
+#define QOS_QDISC_ADD           10
+#define QOS_QDISC_CHANGE        11
+#define QOS_QDISC_DELETE        12
+
+#define QOS_CLASS_ADD           14
+#define QOS_CLASS_CHANGE        15
+#define QOS_CLASS_DELETE        16
+
+#define QOS_FILTER_ADD          18
+#define QOS_FILTER_CHANGE       19
+#define QOS_FILTER_DELETE       20
+
+#define	QOS_MAX_MSG		16
+
+#define QOS_MAX_ATTRS		128
+
+struct qos_request {
+        struct nlmsghdr         n;
+        struct tcmsg            t;
+        char                    buff[4096];
+};
+
+struct qos_msg{
+        struct qos_request req;
+        int action;
+};
+
+struct qos_syscall_msg {
+        struct qos_msg         *msglist;
+        int                     no_of_msgs;
+};
+
+/*qos_get_all_args:
+ *function to copy from user to kernel space
+ */
+extern int 	qos_get_all_args(struct qos_syscall_msg *,struct qos_syscall_msg *);
+
+/*qos_do_conf:
+ *function which does the qos_configuration for one nessage
+ */
+extern int 	qos_do_conf(struct qos_msg *);
+
+
+
+
+#endif
diff -Naur test-for-latech/include/linux/qsocket.h testqf-for-latech/include/linux/qsocket.h
--- test-for-latech/include/linux/qsocket.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/include/linux/qsocket.h	2004-06-11 07:47:29.000000000 -0400
@@ -0,0 +1,177 @@
+/*File          :qsocket.c
+ *Written by    :Rabin Patra & Vibha Rathi
+ *Date          :12 July 2001
+ *
+ *Definations for
+ *1.struct qos_param
+ */
+
+#include <linux/netdevice.h>
+//#include <asm/types.h>
+//#include <linux/pkt_sched.h>
+//#include <net/pkt_cls.h>
+
+#ifndef __QSOCKET_H__
+#define __QSOCKET_H__ 
+
+/*
+ * Only SYS_QSEND is used actually
+ */
+
+#define SYS_QSOCKET     	1               /* sys_qsocket(2)      */
+#define SYS_QBIND        	2               /* sys_qbind(2)        */
+#define SYS_QCONNECT     	3               /* sys_qconnect(2)     */
+#define SYS_QLISTEN      	4               /* sys_qlisten(2)      */
+#define SYS_QACCEPT      	5               /* sys_qaccept(2)      */
+#define SYS_QGETSOCKNAME 	6               /* sys_qgetsockname(2) */
+#define SYS_QGETPEERNAME 	7               /* sys_qgetpeername(2) */
+#define SYS_QSOCKETPAIR 	8               /* sys_qsocketpair(2)  */
+#define SYS_QSEND     		9               /* sys_qsend(2)        */
+#define SYS_QSHUTDOWN 		10
+#define SYS_QCHANGE		11
+#define SYS_QSENDTO		12
+#define SYS_QINFO		16				
+#define SYS_QRECVMSG	 	17		/* sys_qrecvmesg	*/
+#define SYS_QINIT		20
+
+#define	MAX_QOS_PARAM_SIZE	128
+
+struct qos_param{
+	void * 	data;
+	int 	len;
+}; 
+
+#ifndef IFNAMSIZ
+#define IFNAMSIZ 16
+#endif
+
+#ifndef DWCS_VIOLATION
+/* --RW-- */
+#define DWCS_VIOLATION  	0x00000001 /* Window-constraint violation. */
+#define DWCS_WORK_CONS		0x00000002 /* Does task support work-conservation? */
+#define DWCS_NON_DROPPABLE 	0x00000008 /* Set when process is non-preemptive */
+#define DWCS_NON_PREEMPTIVE 0x00000004		/* Set when process is non-preemptive */
+#endif
+
+#define APP_MAX 128
+
+#ifdef NEW_VERSION
+
+struct qos_params
+{
+	int qos_on;
+	int disable;
+	char dev[IFNAMSIZ];
+	char name[IFNAMSIZ];
+	char *app_id;
+	void *attributes;
+};
+
+#else
+
+struct qos_params
+{
+	int qos_on;
+	int disable;
+	char dev[IFNAMSIZ];
+	char name[IFNAMSIZ];
+	char *app_id;
+	void *attributes;
+	int ipg;
+	int old;
+	int oln;
+	int flags; 		/*work conserving or non work conserving*/
+	int attribute; 	/*is the stream droppable or not?*/
+	int server;
+	int use_cpu;
+	int use_net;
+};
+
+#endif
+
+struct packet_flags
+{
+	int drop_flag;
+	int urgent_flag;
+	int fragments;
+};
+
+
+struct qsocket_info
+{
+	unsigned int input_qlen;
+	unsigned int output_qlen;
+	unsigned int missed_deadlines;
+	unsigned int cpu_time;
+	unsigned int delay_jif;
+	unsigned int sent_packets;
+};
+
+#ifdef __KERNEL__
+
+struct qops
+{
+	char id[IFNAMSIZ];
+	int (*create)(struct net_device *dev, void *attributes);
+	int (*add_stream)(struct Qdisc *q, void *attributes, int sock_fd);
+	int (*remove_stream)(struct Qdisc *q, int sock_fd);
+	int (*change_stream)(struct Qdisc *q, void *attributes, int i_ino);
+	int (*get_stream_info)(struct Qdisc *q, int i_ino, void *info);
+};
+
+struct qop_list
+{
+	struct qops *op;
+	struct qop_list *next;
+};
+
+extern struct qop_list *qop_base;
+
+static inline void register_qops(struct qops *ops)
+{
+	/*add to list*/
+	struct qop_list *temp = kmalloc(sizeof(struct qop_list), GFP_KERNEL);
+
+	if(ops == NULL)
+		printk("null passed damint\n");
+
+	temp->op = ops;
+	
+	temp->next = qop_base;
+	qop_base = temp;
+
+	
+	printk(KERN_INFO "Registering qops = %s\n", qop_base->op->id);
+
+}
+
+
+static inline void unregister_qops(struct qops *ops)
+{
+	/*remove from list*/
+}
+
+struct socket_head
+{
+  struct socket_filter *ht[256];       /* a hash table for socket_filters */
+};
+
+
+struct socket_filter
+{
+  struct socket_filter	*next;
+  u32			id;
+  u32                   pid;          /* the pid, and               */
+  unsigned long         fd;           /* the fd to monitor for; or  */
+  unsigned long         i_ino;        /* the inode to monitor for   */
+  struct tcf_result	res;
+#ifdef CONFIG_NET_CLS_POLICE
+  struct tcf_police	*police;
+#endif
+};
+
+
+#endif
+
+#endif
+
diff -Naur test-for-latech/include/linux/sch_dwcs.h testqf-for-latech/include/linux/sch_dwcs.h
--- test-for-latech/include/linux/sch_dwcs.h	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/include/linux/sch_dwcs.h	2004-06-11 07:47:29.000000000 -0400
@@ -0,0 +1,161 @@
+/* 
+ * net/sched/sch_dwcs.h   DWCS algorithm scheduler.
+ *
+ *              This program is free software; you can redistribute it and/or
+ *              modify it under the terms of the GNU General Public License
+ *              as published by the Free Software Foundation; either version
+ *              2 of the License, or (at your option) any later version.
+ *
+ * Authors:     Gregory Losik <gregor@cc.gatech.edu>
+ *              Richard West <west@cc.gatech.edu>
+ *              Christian Poellabauer <chris@cc.gatech.edu>
+ *
+ * Changes:     J.D. Hollis <jdhollis@cc.gatech.edu>
+ *              cleaned up the formatting and added some comments
+ *
+ */
+ 
+
+#define TRUE	1
+#define FALSE	0
+#define MAX_CONNS       255    // GL: Technically it should be 2^16 but lets risk it...
+
+#define DWCS_VIOLATION  	0x00000001 			/* Window-constraint violation. */
+#define DWCS_WORK_CONS		0x00000002 			/* Does task support work-conservation? */
+#define DWCS_NON_DROPPABLE	0x00000008 	
+
+
+
+#include <linux/notifier.h>
+
+
+/* Scheduler attributes. Not all members are necessary for all scheduling policies. */
+typedef struct dwcs_class_attr {
+	// int cd;                    /* Class descriptor. */
+	// unsigned cnt;              /* Number pkts queued for this class. */
+
+	/* JDH: w, s, and f might not be needed as we've got a DWCS qdisc now */
+	double w;                     /* Weight. (For SFQ) */
+	double s;                     /* Start tag. (For SFQ) */
+	double f;                     /* Finish tag. (For SFQ) */
+
+	/* these are the actual, user-definable attributes */
+	long deadline;
+	long readytime;/* ok this requires a little explanation
+					  this is to maintain a specific throughput from the class
+					  thus a stream with packets to send, on an idle network
+					  won't send packets until the ready time has elasped for the 
+					  stream
+				   */
+
+	unsigned long ipg;            /* Inter-packet/msg gap. */
+	unsigned oln;                 /* Original loss numerator. */
+	unsigned old;                 /* Original loss denominator. */
+	
+	/* statistics */
+	unsigned cln;                 /* Current loss numerator. */
+	unsigned cld;                 /* Current loss denominator. */
+	long clt;                     /* Current loss tolerance. */
+	unsigned late;                /* Stats - number late pkts. */
+	unsigned sent;                /* Stats - number pkts sent. */
+	unsigned violations;          /* Stats - number loss tolerance violations. */
+	unsigned long delay;          /* Cumulative delay for this class. */
+	int t;                        /* Simulated time to process pkt. */
+	unsigned window;              /* Packet window size. */
+	unsigned wlate;               /* Count of late pkts in a time window. */
+	unsigned long bytes;          /* Total bytes serviced for this class. */
+	// long start_time;              /* Real-time this class started. */
+	
+	/* GL: since there is no per packet flag, it needs to be per stream... */
+	int droppable;                /* TRUE if packets may be dropped. */
+	unsigned int flags;           /* Flags as specified by user */
+} dwcs_class_attr_t;
+
+
+/* Deadline heap attributes. */
+struct dl_heap {
+	long deadline;                /* Packet deadline. */
+	// int stream;                   /* Stream number. */
+	u32 stream;                   /* Stream number. */
+};
+
+struct sl_heap
+{
+	long readytime;
+	u32 stream;
+};
+
+
+/* Loss tolerance heap attributes. */
+struct lt_heap {
+	int stream;                   /* Stream number. */
+	long deadline;                /* Packet deadline. */
+	int cln;                      /* Current loss numerator. */
+	int cld;                      /* Current loss denominator. */
+	int oln;                      /* Original loss numerator. */
+	int wlate;                    /* Late packets in window. */
+	unsigned long arr_time;       /* Packet arrival time. */
+	long clt;                     /* Current loss tolerance. */
+};
+
+struct dwcs_sched_data;
+ 
+struct dwcs_class
+{
+  struct dwcs_class           *next;          /* hash table link */
+  struct dwcs_class           *next_alive;    /* next class with backlog in this priority band */
+
+  /* Parameters */
+  u32                         classid;        /* the major:minor class id */
+  unsigned char		      priority;       /* class priority */
+  unsigned int		      *socket_num;    /* to be a socket number.... */
+#ifdef CONFIG_NET_CLS_POLICE
+  unsigned char	              police;
+#endif
+  struct Qdisc                *qdisc;         /* Ptr to DWCS discipline that class belongs to */
+  struct Qdisc                *q;             /* Elementary queueing discipline */
+  
+  /* Variables */
+  struct tcf_proto            *filter_list;
+  int		              refcnt;         /* used by _get() and _put() reference tracking */
+  int                         filters;        /* for keeping track the number of filters */
+  struct tc_stats             stats;          /* ??? used by _NET_ESTIMATOR */
+
+  /* DWCS  specific parameters */
+  struct dwcs_class_attr      attr;         /* Low level attributes of a class */
+};
+
+
+
+
+struct dwcs_sched_data
+{
+	struct dwcs_class         *classes[ 16 ]; /* Hash table of all classes. This is where all new calsses get inserted in */
+	struct dwcs_class         *link;           /* Default class for case when filters don't match */
+	unsigned                  classcount;     /* the counder for total # of classes; q->classes[i] has the actual list */
+
+
+	/* DWCS specific attributes */
+	struct dwcs_class         	*next_class;    /* next class from which we will try to dequeue (to be deleted) */
+
+	struct lt_heap          	ltheap[MAX_CONNS];    /* Loss-Tolerance Heap */
+	int                       	ltheap_size;
+	struct dl_heap            	dlheap[MAX_CONNS];    /* Deadline Heap */
+	int                       	dlheap_size;
+	struct sl_heap				slheap[MAX_CONNS];
+	int 						slheap_size;
+	struct timer_list 			wd_timer;	/* Watchdog timer */	
+	
+
+#ifdef CONFIG_PROC_FS
+	struct proc_dir_entry *ent;
+#endif
+
+#ifdef CONFIG_NET_CLS_POLICE
+	struct dwcs_class	    *rx_class;
+#endif
+
+};
+
+
+ 
diff -Naur test-for-latech/include/linux/sched.h testqf-for-latech/include/linux/sched.h
--- test-for-latech/include/linux/sched.h	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/include/linux/sched.h	2004-06-11 07:47:24.000000000 -0400
@@ -46,6 +46,10 @@
 
 #define CLONE_SIGNAL	(CLONE_SIGHAND | CLONE_THREAD)
 
+#ifdef CONFIG_QFABRIC
+#define MAX_UTILIZATION 1000000
+#endif
+
 /*
  * These are the constant used to fake the fixed-point load-average
  * counting. Some notes:
@@ -119,13 +123,56 @@
 #define SCHED_FIFO		1
 #define SCHED_RR		2
 
+#ifdef CONFIG_DWCS
+/* --RW-- */
+#define SCHED_DWCS		3
+#endif
+
+/* --CP-- */
+#ifdef CONFIG_QFABRIC
+#define SCHED_UPCALL_OTHER	4
+#define SCHED_UPCALL_FIFO	5
+#define SCHED_UPCALL_RR		6
+extern struct wait_queue *global_wait_queue;
+extern int upcall_sched_active;
+extern int ECalls_current_flag;
+extern struct task_struct *ECalls_current;
+#endif
+
+#ifdef CONFIG_DWCS
+/* --RW-- */
+#define DWCS_VIOLATION  0x00000001 /* Window-constraint violation. */
+#define DWCS_WORK_CONS	0x00000002 /* Does task support work-conservation? */
+#define DWCS_NON_PREEMPTIVE 0x00000004 /* Set when process is non-preemptive */
+#endif
+
 /*
  * This is an additional bit set when we want to
  * yield the CPU for one re-schedule..
  */
 #define SCHED_YIELD		0x10
 
-struct sched_param {
+#ifdef CONFIG_QFABRIC
+#define NR_TASKS 512
+#define MAX_FDS 1024
+#endif
+
+#if defined(CONFIG_DWCS)||defined(CONFIG_QFABRIC)
+struct dwcs_sched_param {
+	int pid;		/* --FS-- The pid for which ioctl is done. */
+	int policy;		/* --FS-- The selected policy, -1 for unset. */
+  int sched_priority;
+  unsigned long period;		/* --RW-- Request period. Used for setting
+				          DWCS deadlines. */
+  unsigned int own;		/* --RW-- Original window numerator. */
+  unsigned int owd;		/* --RW-- Original window denominator. */
+  unsigned int flags;		/* --RW-- Right now, work-conserving or not. */
+  unsigned long service_time;	/* --RW-- Time to service a process 
+				          every period. */
+};
+#endif
+
+struct sched_param{
 	int sched_priority;
 };
 
@@ -284,6 +331,70 @@
 extern struct user_struct root_user;
 #define INIT_USER (&root_user)
 
+/* --RW-- */
+#ifdef CONFIG_DWCS
+struct dwcs_struct {
+  int cd;			/* Class descriptor. */
+  unsigned long deadline;	
+  unsigned long period;		/* Request period. */
+  unsigned int own;		/* Original window numerator. */
+  unsigned int owd;		/* Original window denominator. */
+  unsigned int cwn;		/* Current window numerator. */
+  unsigned int cwd;		/* Current window denominator. */
+  unsigned int flags;		/* Bitwise flags for future work. */
+  unsigned long ready_time;	/* Time when task can be serviced. */
+  unsigned long service_time;	/* Time to service a process every period. */
+  unsigned long time_serviced;	/* How much time process has been serviced
+				 * so far, in the current processing period.
+				 */
+   /* Energy saving attributes */
+    int cpu_speedup;              /* Describes how much the clockrate can be lowered due
+				     to not max. utilization of the processor scaled by 
+				     100, e.g. if this proc. can be run at half 
+				     clockspeed it is 200 (clockrate * 100 / 
+				     cpu_speedup) */
+
+  /* Statistical attributes. */
+  unsigned int wlate;		/* Count of late tasks in a time window. */
+  unsigned long late;		/* Cumulative missed deadlines. */
+  unsigned long on_time;	/* Cumulative met deadlines. */
+  unsigned long violations;	/* Cumulative window-constraint violations. */
+};
+#endif
+
+/* --RW-- */
+#ifdef CONFIG_DWCS
+#define INIT_DWCS {			\
+		0,			\
+		(unsigned long)(-1),	\
+		(unsigned long)(-1),	\
+		1,			\
+		10,			\
+		1,			\
+		10, 			\
+		DWCS_WORK_CONS,		\
+		0,			\
+		1,			\
+		0,			\
+		0,			\
+		0,			\
+		0,			\
+		0 }
+#endif
+/* End of --RW-- */
+
+/* Artemis */
+#ifdef CONFIG_QFABRIC
+struct qfabric_struct {
+	void *fdqfabric;
+	int orig_weight;
+	int weight;
+	int sw_pending;
+	unsigned long sleep_queue;
+	wait_queue_head_t kecho_queue;
+};
+#endif
+
 struct task_struct {
 	/*
 	 * offsets of these are hardcoded elsewhere - touch with care
@@ -409,6 +520,10 @@
 	int (*notifier)(void *priv);
 	void *notifier_data;
 	sigset_t *notifier_mask;
+
+#ifdef CONFIG_DWCS
+	struct dwcs_struct *dwcs_params;  /* --RW-- */
+#endif
 	
 /* Thread group tracking */
    	u32 parent_exec_id;
@@ -418,6 +533,17 @@
 
 /* journalling filesystem info */
 	void *journal_info;
+
+/* Artemis */
+#ifdef CONFIG_QFABRIC
+	struct qfabric_struct *qfabric;
+	int kthread;
+	int suser_flag;
+	int uaccess_flag;
+	int ecalls_flag;
+/* Useful Measurement Stuff */
+	long syscall_counter;
+#endif
 };
 
 /*
@@ -470,6 +596,7 @@
  *  INIT_TASK is used to set up the first task table, touch at
  * your own risk!. Base=0, limit=0x1fffff (=2MB)
  */
+#ifdef CONFIG_DWCS
 #define INIT_TASK(tsk)	\
 {									\
     state:		0,						\
@@ -509,10 +636,54 @@
     sig:		&init_signals,					\
     pending:		{ NULL, &tsk.pending.head, {{0}}},		\
     blocked:		{{0}},						\
+    dwcs_params:        &init_dwcs,					\
     alloc_lock:		SPIN_LOCK_UNLOCKED,				\
     journal_info:	NULL,						\
 }
-
+#else
+#define INIT_TASK(tsk)	\
+{									\
+    state:		0,						\
+    flags:		0,						\
+    sigpending:		0,						\
+    addr_limit:		KERNEL_DS,					\
+    exec_domain:	&default_exec_domain,				\
+    lock_depth:		-1,						\
+    counter:		DEF_COUNTER,					\
+    nice:		DEF_NICE,					\
+    policy:		SCHED_OTHER,					\
+    mm:			NULL,						\
+    active_mm:		&init_mm,					\
+    cpus_runnable:	-1,						\
+    cpus_allowed:	-1,						\
+    run_list:		LIST_HEAD_INIT(tsk.run_list),			\
+    next_task:		&tsk,						\
+    prev_task:		&tsk,						\
+    p_opptr:		&tsk,						\
+    p_pptr:		&tsk,						\
+    thread_group:	LIST_HEAD_INIT(tsk.thread_group),		\
+    wait_chldexit:	__WAIT_QUEUE_HEAD_INITIALIZER(tsk.wait_chldexit),\
+    real_timer:		{						\
+	function:		it_real_fn				\
+    },									\
+    cap_effective:	CAP_INIT_EFF_SET,				\
+    cap_inheritable:	CAP_INIT_INH_SET,				\
+    cap_permitted:	CAP_FULL_SET,					\
+    keep_capabilities:	0,						\
+    rlim:		INIT_RLIMITS,					\
+    user:		INIT_USER,					\
+    comm:		"swapper",					\
+    thread:		INIT_THREAD,					\
+    fs:			&init_fs,					\
+    files:		&init_files,					\
+    sigmask_lock:	SPIN_LOCK_UNLOCKED,				\
+    sig:		&init_signals,					\
+    pending:		{ NULL, &tsk.pending.head, {{0}}},		\
+    blocked:		{{0}},						\
+    alloc_lock:		SPIN_LOCK_UNLOCKED,				\
+    journal_info:	NULL,						\
+}
+#endif
 
 #ifndef INIT_TASK_SIZE
 # define INIT_TASK_SIZE	2048*sizeof(long)
@@ -718,6 +889,9 @@
  */
 static inline int suser(void)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->suser_flag == 1) return 1;
+#endif
 	if (!issecure(SECURE_NOROOT) && current->euid == 0) { 
 		current->flags |= PF_SUPERPRIV;
 		return 1;
@@ -727,6 +901,9 @@
 
 static inline int fsuser(void)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->suser_flag == 1) return 1;
+#endif
 	if (!issecure(SECURE_NOROOT) && current->fsuid == 0) {
 		current->flags |= PF_SUPERPRIV;
 		return 1;
@@ -742,6 +919,9 @@
 
 static inline int capable(int cap)
 {
+#ifdef CONFIG_QFABRIC
+	if (current->suser_flag == 1) return 1;
+#endif
 #if 1 /* ok now */
 	if (cap_raised(current->cap_effective, cap))
 #else
@@ -884,6 +1064,25 @@
 #define for_each_thread(task) \
 	for (task = next_thread(current) ; task != current ; task = next_thread(task))
 
+
+
+/*
+ * GANEV: This typedef and the external aligned_data symbol declaration
+ *        are needed so that the "aligned_data" will be visible outside
+ *        the kernel to loadable schedulers like DWCS.
+ */
+#ifdef CONFIG_DWCS
+typedef union {
+	struct schedule_data {
+		struct task_struct * curr;
+		cycles_t last_schedule;
+	} schedule_data;
+	char __pad [SMP_CACHE_BYTES];
+} aligned_data_t;
+
+extern aligned_data_t aligned_data[NR_CPUS];
+#endif
+
 #define next_thread(p) \
 	list_entry((p)->thread_group.next, struct task_struct, thread_group)
 
@@ -945,5 +1144,4 @@
 }
 
 #endif /* __KERNEL__ */
-
 #endif
diff -Naur test-for-latech/include/linux/skbuff.h testqf-for-latech/include/linux/skbuff.h
--- test-for-latech/include/linux/skbuff.h	2004-06-11 07:40:02.000000000 -0400
+++ testqf-for-latech/include/linux/skbuff.h	2004-06-11 07:47:24.000000000 -0400
@@ -193,6 +193,10 @@
 	unsigned char	*tail;			/* Tail pointer					*/
 	unsigned char 	*end;			/* End pointer					*/
 
+	int 		drop_flag;
+	int 		urgent_flag;
+	int		fragments;
+
 	void 		(*destructor)(struct sk_buff *);	/* Destruct function		*/
 #ifdef CONFIG_NETFILTER
 	/* Can be used for communication between hooks. */
@@ -215,6 +219,10 @@
 #ifdef CONFIG_NET_SCHED
        __u32           tc_index;               /* traffic control index */
 #endif
+#ifdef CONFIG_QFABRIC
+	int deadline;
+	int flags;
+#endif
 };
 
 #define SK_WMEM_MAX	65535
diff -Naur test-for-latech/include/linux/sys.h testqf-for-latech/include/linux/sys.h
--- test-for-latech/include/linux/sys.h	2004-06-11 07:40:04.000000000 -0400
+++ testqf-for-latech/include/linux/sys.h	2004-06-11 07:47:24.000000000 -0400
@@ -4,7 +4,7 @@
 /*
  * system call entry points ... but not all are defined
  */
-#define NR_syscalls 256
+#define NR_syscalls 280
 
 /*
  * These are system calls that will be removed at some time
